package basic

import "github.com/iapologizewhenimwrong/Vestmore_GO/utils/log"

// 全局返回的结构体
type Response struct {
	Data      interface{} `json:"data"`
	ErrorCode int         `json:"error_code"`
	ErrorText string      `json:"error_text"`
	IsSuccess bool        `json:"success"`
}

func (resp *Response) Error(errcode *ErrorCode, Data ...interface{}) *Response {
	if resp == nil {
		resp = &Response{}
	}
	resp.ErrorCode = errcode.Code
	resp.ErrorText = errcode.Message
	resp.IsSuccess = false
	resp.setData(Data)
	log.Error(resp.ErrorText)
	return resp
}

func (resp *Response) ErrorErr(Code int, err error, Data ...interface{}) *Response {
	if resp == nil {
		resp = &Response{}
	}
	resp.ErrorCode = Code
	resp.ErrorText = err.Error()
	resp.IsSuccess = false
	resp.setData(Data)
	log.Error(resp.ErrorText)
	return resp
}

func (resp *Response) ErrorMsg(Code int, Message string, Data ...interface{}) *Response {
	if resp == nil {
		resp = &Response{}
	}
	resp.ErrorCode = Code
	resp.ErrorText = Message
	resp.IsSuccess = false
	resp.setData(Data)
	log.Error(resp.ErrorText)
	return resp
}

func (resp *Response) Success(Data ...interface{}) *Response {
	if resp == nil {
		resp = &Response{}
	}
	resp.IsSuccess = true
	resp.setData(Data)
	return resp
}

func (resp *Response) setData(Data []interface{}) {
	if len(Data) == 0 {
		resp.Data = []interface{}{}
		return
	}

	if len(Data) == 1 {
		resp.Data = Data[0]
	} else {
		resp.Data = Data
	}
}
